LINUX.ORG.RU

На сайте «Компьютерры» опубликовано интервью с разработчиком Deepsolver

 ,


0

1

Существующие менеджеры пакетов для Linux часто критикуют за высокую для неопытных пользователей сложность, трудности с разрешением зависимостей между пакетами и тому подобные вещи. О новых подходах к управлению установленными программами задумываются разработчики многих дистрибутивов, и российские компании не исключение. Инженер-программист «Альт Линукс», кандидат технических наук Михаил Пожидаев рассказал «Компьютерре» о Deepsolver — перспективной разработке, которая может заменить в дистрибутивах ALT Linux использующийся сейчас «Advanced Packaging Tool» (APT).

>>> Подробности

★★

Проверено: maxcom ()

Ответ на: комментарий от lucentcode

Чего я не пойму, так почему не изменить просто саму ОС так, что-бы одновременно разное ПО подтягивало нужные им версии библиотек? Создать пакеты с ПО, которые ставятся в /opt к примеру. И монтирует что нужно перед запуском ПО так, что-бы у программы под рукой было нужное именно ей окружение из нужных версий библиотек и других ресурсов. Тогда проблема с зависимостями будет решатся просто - какая версия пакета, от которого ПО зависит нужна - ту и получит данный пакет.

+1000

А есть такое в других линуксах?

vold ★★★★★ ()
Ответ на: комментарий от raorn

Они отражают, а ты просто не умеешь читать.

Цитаты - однозначно нет. Исходя из цитат, всё нормально.

AS ★★★★★ ()
Ответ на: комментарий от lucentcode

Тогда проблема с зависимостями будет решатся просто - какая версия пакета, от
которого ПО зависит нужна - ту и получит данный пакет.

Кажется излишне заморочено. Уж лучше «всё своё ношу с собой» для ограниченного набора ПО. Такого вот нежного.

AS ★★★★★ ()
Ответ на: комментарий от AS

Цитаты - однозначно нет. Исходя из цитат, всё нормально.

Удачного мантейнерства.

raorn ()
Ответ на: комментарий от raorn

Цитаты - однозначно нет. Исходя из цитат, всё нормально.

Удачного мантейнерства.

То есть, дешифровки цитат не будет ? :-) Ну, спасибо...

AS ★★★★★ ()
Ответ на: комментарий от lucentcode

Это полбеды, вопрос ещё и в фантастических интерфейсах и принципах работы которые любят изобретать писатели редакторов для линукса, просто взять готовую модель у проприетарщиков и улучшить им не интересно.

Napilnik ★★★★★ ()
Ответ на: комментарий от lucentcode

один bleder показал достойную стабильность

Так изначально он был проприетарный и не под линукс - проприетарность кончилась а хорошо спланированная архитектура осталась:)

Napilnik ★★★★★ ()
Ответ на: комментарий от raorn

Это другая крайность, когда проги раскидываются со всеми требуемыми им либами по разным каталогам. Много дублирования. А я имею ввиду разделяемые библиотеки разных версий на уровне системы.

vold ★★★★★ ()

К шестой странице треда пояснение, чем оно лучше альтернатив, так и не прозвучало. На сайте только сравнение производительности с apt-rpm. И так оно с апреля уже тянется.

AP ★★★★★ ()
Ответ на: комментарий от AP

Нет, ну как же. Оно написано не на языке python, не использует решение NP-полной задачи и, что самое главное, разработано компанией ALT Linux. Сразу три преимущества!

raorn ()
Ответ на: комментарий от vold

Ну например в Debian/Ubuntu в имя пакета с либой встроен SONAME в обязательном, если не ошибаюсь, порядке.

raorn ()
Ответ на: комментарий от AS

Нужны. Только они не знают об этом. Когда граблю в библиотеке найдут, Вы сами будете все приложения пересобирать, которые её используют ?

В винде и маках такой проблемы просто нет. Потому и вопрос был почему бы не сделать так-же в линуксе? Зачем обычному пользователю вообще думать о библиотеках и т.п.?

А Вам место на диске и в памяти не хочется поэкономить, не держать один и тот же код в смысле ? А скорость загрузки приложений Вас тоже совсем-совсем не интересует ?

Опять же если речь идет о разных осях, по скорости работы на схожем железе и занимаемому дисковому пространству все они + - одинаковые.

anonymous ()
Ответ на: комментарий от anonymous

Когда граблю в библиотеке найдут, Вы сами будете все приложения пересобирать, которые её используют ?

В винде и маках такой проблемы просто нет

А как поступают на венде и маке, когда в широко распространенной либе находят ошибку?

tailgunner ★★★★★ ()
Ответ на: комментарий от AS

6 пунктов.. В дженте больше делается одной(!) строчкой..

CFLAGS="ключи оптимизации" USE="функции пакета" emerge -bgk пакет

Далее все автоматом скачивается, конфигурируется, компилируется, запаковывается, устанавливается (ежели бинарник такой уже готов, то предыдущие пункты пропускаются). По моему так удобнее.

P.S. Ключ gk указывает при наличии готового бинарника установить из него, ключ b просит в случае компиляции упаковать результат в пакет для использования в дальнейшем.

Вообще CFLAGS и USE прописываются разок в других местах и все сводится к

emerge -bgk пакет

glibych ★★ ()
Ответ на: комментарий от tailgunner

А как поступают на венде и маке, когда в широко распространенной либе находят ошибку?

Очевидно выпускают обновление для о/с программы, не?

Только при чем здесь гимор с зависимостями? Речь шла о том, что при отсутствии сети например, поставить пакет который потребует еще кучу других пакетов будет невозможно.

anonymous ()
Ответ на: комментарий от anonymous

а откуда ты берёшь вендософт, если интернета нет?

anonymous ()
Ответ на: комментарий от anonymous

В винде и маках такой проблемы просто нет.

Три раза «ха». Если Вы про неё не в курсе, это не значит, что её нет. Она как тот суслик.

по скорости работы на схожем железе и занимаемому дисковому пространству все они + - одинаковые.

Это тоже просто кажется. Либо на это влияют какие-то иные факторы.

AS ★★★★★ ()
Ответ на: комментарий от AP

О, да тут сам капитан Ad hominem всплыл! Приветствую!

System requirements... Microsoft® Windows® XP* with Service Pack 3 or Windows 7 with Service Pack 1

Ты хочешь сказать, что эти SP не интегрированы в дистрибутив на болванке? Не говори что не знал, врунишка.

anonymous ()
Ответ на: комментарий от glibych

6 пунктов.. В дженте больше делается одной(!) строчкой..

Это совсем не то же самое, что правка зависимостей и параметров вызова, например, configure.

Далее все автоматом ... конфигурируется

Это как ? :-) Или речь про пресловутую оптимизацию под процессор только ?

Вообще CFLAGS и USE прописываются разок в других местах и все сводится к

А зачем их все одинаково пересобирать ? Если речь про установку из исходников ? В общем, это просто другой подход. Совсем. Не надо из ALT делать Gentoo, Gentoo и так уже есть.

AS ★★★★★ ()
Ответ на: комментарий от anonymous

Очевидно выпускают обновление для о/с программы, не?

Что толку выпускать обновление, если куча других программ уже собрана с неправильной библиотекой ? Исправление надо ждать для них для всех. И все обновлять.

AS ★★★★★ ()
Ответ на: комментарий от Napilnik

Это точно. А почему бы над основной архитектурой открытых проектов не работать как над коммерческим ПО? В закрытой группе и т.п. А потом выкатив ядро ПО, можно принимать навороты от сообщества в виде модулей. Будет тоже хорошо спланированная архитектура. Главно что-бы разработчики основного ядра программы не позволяли абы кому переделывать ядро в непонятного монстра.

lucentcode ★★★★★ ()
Ответ на: комментарий от Napilnik

И это тоже. А юзер потом узрев их творчество впадает в прострацию...

lucentcode ★★★★★ ()
Ответ на: комментарий от anonymous

а откуда ты берёшь вендософт, если интернета нет?

Молодому поколению неизвестны другие носители кроме интернета?

anonymous ()
Ответ на: комментарий от anonymous

Ты хочешь сказать

Не просто хочу сказать, а говорю. Сразу видно, что ты никогда не ставил сервис-паки, чтобы нужный софт на винду встал.

AP ★★★★★ ()
Ответ на: комментарий от anonymous

Кстати, с макосью та же фигня: там тоже приходится периодически накатывать обновление системы до новой версии, чтобы удовлетворить зависимости. И периодически софт ВНЕЗАПНО перестаёт устанавливаться на систему трёхлетней давности. Достаточно вспомнить лулзы с обновлением CoreImage лет пять назад.

AP ★★★★★ ()
Ответ на: комментарий от AS

Можно вообще систему песочниц создать,а в адресное пространство программы загружать только нужные бибилиотеки. Грузить их может специальный загрузчик на основе манифеста идущего с программой, при этом пакет может носить с собой свои индивидуальные версии либ, или будут подгружаться именно нужные либы. Удобно и просто. Если ввести проверку подписи либ соответвующими ключами, то можно ещё и безопасность повысить... ПО будет знать, что либа подлинная, а не пропатченная Васей Пупкиным.

lucentcode ★★★★★ ()
Ответ на: комментарий от AS

Это совсем не то же самое, что правка зависимостей и параметров вызова, например, configure.

А как ты думал работают USE флаги?)

Это как ? :-) Или речь про пресловутую оптимизацию под процессор только ?

Под процессор или группу процессоров, под видеокарту или группу видеокарт и т.д. И конечный пакет создается только с нужным данному парку машин функционалом. Автоматически.

А зачем их все одинаково пересобирать ? Если речь про установку из исходников ?

Кто сказал одинаково?)) В альте и в других бинарных дистрибутивах? Да во всех бинарных одинаковая оптимизация. В gentoo можно хоть каждый пакет не только наделить нужными функциями персонально, но и оптимизировать со своими ключами. В make.conf только умолчальные параметры прописываются. Причем делается это все настолько просто, насколько неудобно выполнять те 6 пунктов для rpm.

В общем, это просто другой подход. Совсем. Не надо из ALT делать Gentoo, Gentoo и так уже есть.

Вот из-за того что есть Gentoo, зачем делать что-то еще?? Лучше бы ebuild для gentoo помогали дорабатывать)))

Без возможности автоматической установки из сорцов менеджер пакетов убогое поделие.

glibych ★★ ()
Ответ на: комментарий от vold

Есть. Вот только разработчик не очень активно работает над проектом, года два уже нет новых релизов. Но идея мне нравится, красиво придумано. В BeOS вообще с версиями софта не заморачивались, но там всё упростили просто ещё больше.

lucentcode ★★★★★ ()
Ответ на: комментарий от AS

Три раза «ха». Если Вы про неё не в курсе, это не значит, что её нет. Она как тот суслик.

Проблем с зависимостями программ? Да, очень редкие программы NET обновить требуют, если он еще не.

Это тоже просто кажется. Либо на это влияют какие-то иные факторы.

Когда кажется надо что делать? Правильно. Для всех остальных случаев есть бенчмарки, кадры в секунду, или секундомер.

Что толку выпускать обновление, если куча других программ уже собрана с неправильной библиотекой ? Исправление надо ждать для них для всех. И все обновлять.

Ну уж не нагоняйте ужосов, со времен пользования Win 3.11 таких глобальных катастроф не припомню.

anonymous ()
Ответ на: комментарий от AP

Сразу видно, что ты никогда не ставил сервис-паки

Спасибо кэпи, в очередной раз восхищаюсь вашими телепатическими способностями!

И периодически софт ВНЕЗАПНО перестаёт устанавливаться на систему трёхлетней давности

Очевидно на линукс 3-х летней давности современное п/о устанавливается без проблем. А кстати как в win7 с этим обстоят дела? оси уже 3 года как.

anonymous ()
Ответ на: комментарий от glibych

А как ты думал работают USE флаги?)

А зачем они общие на всё ? :-)

Вот из-за того что есть Gentoo, зачем делать что-то еще??

Ну вот, с этого и надо было начинать. Да, Gentoo не нужна. :-)

AS ★★★★★ ()
Ответ на: комментарий от anonymous

Проблем с зависимостями программ?

Нет, проблемы с обновлением библиотек. Которые таскают за собой все, и каждый свою копию.

AS ★★★★★ ()
Ответ на: комментарий от lucentcode

при этом пакет может носить с собой свои индивидуальные версии либ

Это из серии «с чем боролись».

AS ★★★★★ ()
Ответ на: комментарий от anonymous

Очевидно на линукс 3-х летней давности...

Очевидно ты призываешь сантехников зафиксировать слив.

AP ★★★★★ ()
Ответ на: комментарий от anonymous

Очевидно на линукс 3-х летней давности современное п/о устанавливается без проблем.

точнее с такими же проблемами, как и в любой другой ОС.

Popil_Bablosov ()

Еще один SAT-солвер для зависимостей?

Неплохо, конечно, но уже далеко не оригинально.

zhuravlik ★★★★ ()
Ответ на: комментарий от AS

А зачем они общие на всё ? :-)

Издеваешься или действительно не понимаешь? Есть глобальные USE флаги, например, указывающие применять gtk+ для всех пакетов. А есть индивидуальные для конкретных. Например, в конкретном пакете можно отключить тот же gtk+ и не устанавливать обертку для иксов. Можно, к примеру, вообще не включать куски кода с ненужным вариантом sse команд, т.е. они физически не войдут в состав конечного пакета (не просто отключение в CFLAGS, где прописывается только задействование, а можно указать не включать именно данный код в пакеты с помощью USE вообще).

Ну вот, с этого и надо было начинать. Да, Gentoo не нужна. :-)

Хорошо подумал? На каком количестве разного оборудования может заработать альт и на каком генту? Без альта прожить можно легко, а вот без генту придется не сладко.

glibych ★★ ()
Ответ на: комментарий от AP

Очевидно ты призываешь сантехников зафиксировать слив.

Очевидно даже капитанам иногда нужно приводить факты. Впрочем не осуждаю. Ты как-то внезапно посреди дискуссии всплыл, не уловил начала да и зачем тебе это, твоя миссия в другом.

anonymous ()
Ответ на: комментарий от Napilnik

Почему появляется NP-сложность?

Потому и появляется что крупные программы в которых правильные зависимости не вкомпилены имеют тенденцию рассыпаться а ментейнеры не железные чтобы всё успевать починить.

И как тут поможет пакетный менеджер. Что зависимости могут выдать косяк понятно, но как спасет положение пакетный менеджер - вот основной вопрос. Причем это спасение походу имеет сложность NP. Вот только отчего?

VoDA ★★ ()
Ответ на: комментарий от glibych

Хорошо подумал ?

Конечно. Ровно столько же, сколько думал сказавший «Вот из-за того что есть Gentoo, зачем делать что-то еще??».

Ещё раз повторяю, не надо рассказывать про дистрибутивы, требующие пересборки ради установки.

На каком количестве разного оборудования может заработать альт и на каком генту?

Я не сталкивался с тем оборудованием, куда бы ALT у меня не встал. Будет - будем говорить.

Без альта прожить можно легко, а вот без генту придется не сладко.

Я прекрасно живу без Генту. Реально, без кого будет сложно, это без RedHat. Возможно, без Дебиан, может быть, с Убунту. И лично мне будет менее удобно без ALT.

AS ★★★★★ ()
Ответ на: комментарий от lucentcode

Некоторые проекты, типа редактора, делать нужно заново, например в лазарусе со статической компиляцией, но некому.

Napilnik ★★★★★ ()
Ответ на: комментарий от VoDA

но как спасет положение пакетный менеджер - вот основной вопрос

Его авторы надеются что более сложная технология подсчёта подсчитает лучше и уменьшит количество косяков, как-нибудь, сколько-нибудь. Имхо, статическая сборка некоторых проблемных приложений даст положительный эффект быстрее. Те же кодеки постоянно мутируют и если редактор будет использовать пропатченные версии вкомпиленные статически, то при открытии файлов многие баги на всех дистрибутивах будут одинаковые и поддающиеся исправлению. Например, x264 могут ломать каждую неделю и для поддержки совместимости плееры/редакторы нужно править как можно чаще. В результате, силы разработчиков расходуются на поддержание существующих фич а не на добавление новых.

Napilnik ★★★★★ ()
Ответ на: комментарий от anonymous

воспользуйся техподдержкой. Тебе помогут

говорят тебе проще вынести винду и с нуля всё запилить

goingUp ★★★★★ ()
Ответ на: комментарий от anonymous

Почему бы не сделать как в Windows, где само понятие зависимость отсутствует как класс

Я вы вот мне расскажите, я запустил в виндовс инсталлятор, а он мне говорит, вот я хочу ххх.длл записать на диск, а на том месте уже лежит какая-то другой версии, перезаписать? Что мне нажимать, yes или no? Или допустим удаляю что-то а у меня спрашивают, вот надо удалить ххх.длл, но возможно кто-то ей еще пользуется, удалять?

goingUp ★★★★★ ()

не согласен с этим бредом, вернее с бредом тех кто выдвигает такие идеии и мнение. Фзе Apt вообще не в конкуренции. когда я пришел в linux мне сразу стало все понятно. Пакеты это преимущество а не минус

TIAXA ()
Вы не можете добавлять комментарии в эту тему. Тема перемещена в архив.